//
//  Debug.h
//  CCTable
//
//  Created by Sangwoo Im on 6/3/10.
//  Copyright 2010 Sangwoo Im. All rights reserved.
//


#ifdef __OPTIMIZE__
#   define __DISABLE_CCLOG__
#   define __DISABLE_CCASSERT__
#endif

#if !TARGET_IPHONE_SIMULATOR
#   ifndef __DISABLE_CCLOG__
#       define __DISABLE_CCLOG__
#   endif
#endif

#ifdef __DISABLE_CCLOG__
#   define CCLog(...)
#   define CCMETHOD_ENTER()
#   define CCMETHOD_EXIT()
#else
#   define CCLog(...)       NSLog(__VA_ARGS__)
#   define CCMETHOD_ENTER() NSLog(@"%s: %s: Enter", __FILE__, __FUNCTION__)
#   define CCMETHOD_EXIT()  NSLog(@"%s: %s: Exit", __FILE__, __FUNCTION__)
#endif

#ifdef __DISABLE_CCASSERT__
#   define CCAssert(...)
#else
#   define CCAssert(...) NSAssert(__VA_ARGS__)
#endif